unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmRegExp = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    btnReplace: TButton;
    edtBefore: TEdit;
    edtAfter: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    TabSheet2: TTabSheet;
    btnAugment: TButton;
    mText: TMemo;
    btnMatch: TButton;
    mMatches: TMemo;
    Label3: TLabel;
    Label4: TLabel;
    edtPattern: TEdit;
    Label5: TLabel;
    TabSheet3: TTabSheet;
    Label6: TLabel;
    mPostcodes: TMemo;
    Label7: TLabel;
    Edit1: TEdit;
    btnPostcodeMatch: TButton;
    Label8: TLabel;
    mMatchedPostcodes: TMemo;
    TabSheet4: TTabSheet;
    Label9: TLabel;
    mSentences: TMemo;
    Edit2: TEdit;
    btnApply: TButton;
    Label10: TLabel;
    mAdvancedResults: TMemo;
    Label11: TLabel;
    TabSheet5: TTabSheet;
    Label12: TLabel;
    mSource: TMemo;
    Label13: TLabel;
    Edit3: TEdit;
    btnAdvancedApply: TButton;
    Label14: TLabel;
    mResults: TMemo;
    TabSheet6: TTabSheet;
    Label15: TLabel;
    Memo1: TMemo;
    Edit4: TEdit;
    Label16: TLabel;
    Button1: TButton;
    Label17: TLabel;
    Memo2: TMemo;
    procedure btnMatchClick(Sender: TObject);
    procedure btnReplaceClick(Sender: TObject);
    procedure btnAugmentClick(Sender: TObject);
    procedure btnPostcodeMatchClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnAdvancedApplyClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRegExp: TfrmRegExp;

implementation

uses VBScript_RegExp_55_TLB, MSXML2_TLB;

{$R *.dfm}

procedure TfrmRegExp.btnMatchClick(Sender: TObject);
var reRegExp          : IRegExp2;
    i                 : integer;
    mcMatchCollection : MatchCollection;
    mcMatch           : Match;
begin
  reRegExp :=  CoRegExp.Create;

  reRegExp.Pattern    := '[0-9]+';
  reRegExp.Global     :=true;
  reRegExp.Multiline  :=true;

  mcMatchCollection := reRegExp.Execute(mText.Text) as MatchCollection;

  mMatches.Clear;
  for i := 0 to mcMatchCollection.Count - 1 do begin
    mcMatch := mcMatchCollection.Item[i] as Match;
    mMatches.Lines.Add(mcMatch.Value);
  end;
end;

(* ************************************************************************* *)

procedure TfrmRegExp.btnReplaceClick(Sender: TObject);
var reRegExp   : IRegExp2;
    sStr       : string;
    strReplace : OleVariant;
begin
  reRegExp :=  CoRegExp.Create;

  // Original string
  sStr:='Hello big Blue world';

  // Replace 'Blue' with 'Red'
  reRegExp.Pattern := 'Blue';
  strReplace       := 'Red';
  reRegExp.Global  := false;

  edtBefore.Text := sStr;

  sStr:=reRegExp.Replace(sStr, strReplace);

  edtAfter.Text := sStr;
end;

(* ************************************************************************* *)

procedure TfrmRegExp.btnAugmentClick(Sender: TObject);
var reRegExp   : IRegExp2;
    sStr       : string;
    strReplace : OleVariant;
begin
  reRegExp :=  CoRegExp.Create;

  // Original string
  sStr:='How now, brown cow';

  // Augment 'How now cow'
  reRegExp.Pattern := '[n|c]ow';
  strReplace       := '$+ pat';
  reRegExp.Global  := true;

  edtBefore.Text := sStr;

  sStr:=reRegExp.Replace(sStr, strReplace);

  edtAfter.Text := sStr;
end;

(* ************************************************************************* *)

procedure TfrmRegExp.btnPostcodeMatchClick(Sender: TObject);
var reRegExp          : IRegExp2;
    i                 : integer;
    mcMatchCollection : MatchCollection;
    mcMatch           : Match;
begin
  reRegExp :=  CoRegExp.Create;

  reRegExp.Pattern    := '[A-Z]{2}([0-9]|[0-9]{2})\s\d[A-Z]{2}';

  reRegExp.Global     :=true;
  reRegExp.Multiline  :=true;

  mcMatchCollection := reRegExp.Execute(mPostcodes.Text) as MatchCollection;

  mMatchedPostcodes.Clear;
  for i := 0 to mcMatchCollection.Count - 1 do begin
    mcMatch := mcMatchCollection.Item[i] as Match;
    mMatchedPostcodes.Lines.Add(mcMatch.Value);
  end;
end;

(* ************************************************************************* *)

procedure TfrmRegExp.btnApplyClick(Sender: TObject);
var reRegExp          : IRegExp2;
    i                 : integer;
    mcMatchCollection : MatchCollection;
    mcMatch           : Match;
begin
  reRegExp :=  CoRegExp.Create;

  // Match all sentences that begin with "The", and return the entire sentence
  reRegExp.Pattern    := '^The.*';
//  reRegExp.Pattern    := '.*mat$';
  reRegExp.Global     :=true;
  reRegExp.Multiline  :=true;

  mcMatchCollection := reRegExp.Execute(mSentences.Text) as MatchCollection;

  mMatchedPostcodes.Clear;
  for i := 0 to mcMatchCollection.Count - 1 do begin
    mcMatch := mcMatchCollection.Item[i] as Match;
    mAdvancedResults.Lines.Add(mcMatch.Value);
  end;
end;

(* ************************************************************************* *)

procedure TfrmRegExp.btnAdvancedApplyClick(Sender: TObject);
var
  i, j: integer;
  reRegExp: RegExp;
  mcMatchCollection: MatchCollection;
  mMatch: Match;
  smSubMatches: ISubMatches;
begin
  reRegExp := CoRegExp.Create;

  reRegExp.Pattern    := '(\d{2})-(\d{3})';
  reRegExp.IgnoreCase := true;
  reRegExp.Global     := true;
  mcMatchCollection   := reRegExp.Execute(mSource.Text) as MatchCollection;

  for i := 0 to mcMatchCollection.Count - 1 do  begin
    mMatch := mcMatchCollection.Item[i] as Match;
    mResults.Lines.Add(mMatch.Value);
    smSubMatches := mMatch.SubMatches as SubMatches;

    for j := 0 to smSubMatches.Count - 1 do begin
      // Secondary validation
      //if (j = 0) then if StrToInt(smSubMatches.Item[j]) in [12,23] then
      //  mResults.Lines.Add('yes');

        mResults.Lines.Add('    ' + '$' + inttostr(j + 1) + ' = ' + VarToStr(smSubMatches.Item[j]));
    end;
  end;
end;

(* ************************************************************************* *)

procedure TfrmRegExp.Button1Click(Sender: TObject);
var reRegExp          : IRegExp2;
    i                 : integer;
    mcMatchCollection : MatchCollection;
    mcMatch           : Match;
begin
  reRegExp :=  CoRegExp.Create;

  reRegExp.Pattern    := Edit4.Text;

  reRegExp.Global     :=true;
  reRegExp.Multiline  :=true;

  mcMatchCollection := reRegExp.Execute(Memo1.Text) as MatchCollection;

  Memo2.Clear;
  for i := 0 to mcMatchCollection.Count - 1 do begin
    mcMatch := mcMatchCollection.Item[i] as Match;
    Memo2.Lines.Add(mcMatch.Value);
  end;
end;

(* ************************************************************************* *)

end.
